%global commit 232ed17142da1c8bb6a39179018f8278b122aada
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global date 20160624


Name:           python-deap
Version:        1.0.1
Release:        7.%{date}git%{shortcommit}%{?dist}
Summary:        Distributed Evolutionary Algorithms in Python

License:        LGPLv3
URL:            https://www.github.com/deap
Source0:        https://github.com/DEAP/deap/archive/%{commit}.tar.gz#/deap-%{shortcommit}.tar.gz

# Tweak the usage of 2to3 in setup.py; this makes it work for the
# tests (so long as we're using setuptools, which we are; distutils
# doesn't understand this). Similar to
# https://github.com/DEAP/deap/pull/131 , but without pypy-specific
# bits we don't care about
Patch0:         python-deap-2to3.patch

BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  python2-pypandoc
BuildRequires:  python2-nose

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-pypandoc
BuildRequires:  python3-nose
BuildRequires:  python3-numpy

# documentation
BuildRequires:  python2-sphinx
BuildRequires:  texlive-scheme-basic
BuildRequires:  texlive-ucs
BuildRequires:  python2-numpy
BuildRequires:  python2-matplotlib

%global _description \
DEAP is a novel evolutionary computation framework for rapid         \
prototyping and testing of ideas that implements a number of genetic \
optimization algorithms behind a common interface.

%description %_description

%package -n     python2-deap
Requires:       python2-numpy
Summary:        %{summary}
%{?python_provide:%python_provide python2-deap}

%description -n python2-deap %_description

%package -n     python3-deap
Requires:       python3-numpy
Summary:        %{summary}
%{?python_provide:%python_provide python3-deap}

%description -n python3-deap %_description

%package -n python-deap-doc
Summary:        Documentation for deap
BuildArch:      noarch
%description -n python-deap-doc
%{summary}.

%prep
%autosetup -n deap-%{commit}
sed -i 's/\["git", "rev-parse", "HEAD"\]/["echo", "deap-%{version}-%{release}"]/' \
    doc/conf.py

# Work around for https://github.com/matplotlib/matplotlib/issues/7313
sed -i -r 's/arange\(([-0-9.]+), ([-0-9.]+), [-0-9.]+\)/linspace(\1, \2, 20)/' doc/code/benchmarks/*.py

%build
%py2_build
%py3_build

# generate html docs
PYTHONPATH=$(echo build/lib.linux-*-%{python_version}/) sphinx-build-2 doc build/html

# remove the sphinx-build leftovers
rm -rf build/html/.{doctrees,buildinfo}

%global _docdir_fmt %{name}

%install
%py2_install
%py3_install

%check
%{__python2} setup.py nosetests
%{__python3} setup.py nosetests

%files -n python2-deap
%license LICENSE.txt
%doc README.md
%{python2_sitearch}/deap
%{python2_sitearch}/deap-*.egg-info

%files -n python3-deap
%license LICENSE.txt
%doc README.md
%{python3_sitearch}/deap
%{python3_sitearch}/deap-*.egg-info

%files -n python-deap-doc
%license LICENSE.txt
%doc build/html

%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-7.20160624git232ed17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Jan 16 2018 Iryna Shcherbina <ishcherb@redhat.com> - 1.0.1-6.20160624git232ed17
- Update Python 2 dependency declarations to new packaging standards
  (See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3)

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-5.20160624git232ed17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-4.20160624git232ed17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-3.20160624git232ed17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sat Jan 07 2017 Adam Williamson <awilliam@redhat.com> - 1.0.1-2.20160624git232ed17
- Tweak setup.py so Python 3 tests will run on 2to3'ed code
- Add appropriate buildrequires and enable tests
- Remove some unneeded conditionals for EOL Fedora releases

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com>
- Rebuild for Python 3.6

* Tue Oct 18 2016 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 1.0.1-1.20160624git232ed17
- Update to latest git snapshot
- The version was wrong (upstream never released anything after
  1.0.1).  I forgot to actually create an update with the initial
  version of this package. Luckily, this package was only built in
  F22-24, and failed to build in rawhide, so it was never possible to
  install it from repositories. I think this means it is possible to
  lower the version without bumping the epoch.

* Thu Apr 07 2016 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 1.1.10-0.20160402gita4dc752
- Initial package.
